Index: trunk/LMDZ.TITAN/libf/phytitan/clesphys.h
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/clesphys.h	(revision 174)
+++ trunk/LMDZ.TITAN/libf/phytitan/clesphys.h	(revision 175)
@@ -11,21 +11,36 @@
        INTEGER nbapp_rad, nbapp_chim, iflag_con, iflag_ajs
        REAL    ecritphy
+       INTEGER lev_histmth, lev_histday
        REAL    solaire
+
+! Parametres pour PBL:
        REAL    z0, lmixmin
-       REAL    ksta, inertie
+       REAL    ksta
        LOGICAL ok_kzmin
-       INTEGER lev_histmth, lev_histday
+
+! Parametres surface:
+       REAL    inertie
+
+! Parametres Chimie:
        logical chimi,ylellouch,hcnrad
        integer vchim,aerprod,htoh2
-       integer microfi,cutoff
-       real    tx,tcorrect
+       
+! Parametres Microphysique:
+       integer microfi,cutoff,clouds
+       real    tx,tcorrect,p_prodaer
+       real    xnuf 
 
 
-       COMMON/clesphys/cycle_diurne, soil_model,                        &
-     &     ok_orodr, ok_orolf, ok_gw_nonoro, nbapp_rad, nbapp_chim      &
-     &     , ecritphy                                                   &
-     &     , iflag_con, iflag_ajs, solaire, z0, lmixmin, ksta           &
-     &     , ok_kzmin, lev_histmth, lev_histday                         &
-     &     , inertie, chimi,vchim,aerprod,htoh2,ylellouch,hcnrad        &
-     &     , microfi,cutoff,tx,tcorrect
+       COMMON/clesphys_i/                                               &
+     &     nbapp_rad, nbapp_chim, iflag_con, iflag_ajs,                 &
+     &     lev_histmth, lev_histday, vchim,aerprod,htoh2,               &
+     &     microfi,cutoff,clouds
 
+       COMMON/clesphys_r/                                               &
+     &     ecritphy, solaire, z0, lmixmin, ksta, inertie,               &
+     &     tx,tcorrect,p_prodaer,xnuf
+
+       COMMON/clesphys_l/cycle_diurne, soil_model,                      &
+     &     ok_orodr, ok_orolf, ok_gw_nonoro, ok_kzmin,                  &
+     &     chimi,ylellouch,hcnrad
+
Index: trunk/LMDZ.TITAN/libf/phytitan/cnuages3D.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/cnuages3D.F	(revision 175)
+++ trunk/LMDZ.TITAN/libf/phytitan/cnuages3D.F	(revision 175)
@@ -0,0 +1,437 @@
+         subroutine cnuages(
+     &   tq,tqc1,tqc2,tqc3,tqcn,gaz1,gaz2,gaz3,   ! aerosol/glace/gas
+     &   ddt)
+
+c
+c
+c  °
+c              °
+c  SERT A APPELE LA ROUTINE MICROPHYSIQUE DES NUAGES 
+c
+c     °
+c  ICI ON NE FAIT QUE LA NUCLEATION/CONDENSATION 
+c  ET GESTION°DES NOYAUX. LA SEDIMENTATION EST DANS
+c  SNUAGES.F
+c            °   °
+c
+c        °
+c                °
+c              °   °
+c                      
+c                  °   °
+c                   °  
+c                    ° °
+c                   ° \|/  °
+c                    (@ @)°
+c-----------------oOo--O--oOo--------------------------
+c                        
+c
+c
+c Interface entre physiq.F et les routines n_<nom_compose>.F 
+c
+c Date: 3 Nov 2003
+c
+c   EN ENTREE/SORTIE DE LA ROUTINE
+c ------------------------------------
+c
+c     Les aerosols, noyaux (tq,tqcn) sont en nbre/m^2 dans la colonne
+c     Les  condensats (tqc1,tqc2)   sont en volume/m^2 dans la colonne
+c     Le gaz (gaz1, gaz2) est en fraction molaire
+c
+c   EN APPEL DES ROUTINES NUAGES
+c ------------------------------------
+c
+c     Les aerosols et noyaux doivent etre en nombre /kg d'air
+c     Les condensats doivent etre en volume / kg d'air
+c     Le gaz en kg/kg d'air
+c
+c   LES TENDANCES ET DIFFERENCES SONT HOMOGENES AUX QUANTITES
+c ------------------------------------------------------------
+c
+c
+c------------------------------------------------------
+
+         use dimphy
+         IMPLICIT NONE
+#include "dimensions.h"
+#include "microtab.h"
+#include "varmuphy.h"
+
+         integer NG1,NG,NL 
+         parameter (NG1=1,NG=NG1,NL=llm)
+  
+c*************************************
+c  declaration des variables internes *
+c*************************************
+
+c        INTERNE!        *
+c-----------------------*
+
+         real  tqc1(NG,NL,nrad)
+         real  tqc2(NG,NL,nrad)
+         real  tqc3(NG,NL,nrad)
+         real  tqcn(NG,NL,nrad)
+         real  tq(NG,NL,nrad)
+*
+         real  tdqc1(NG,NL,nrad)
+         real  tdqc2(NG,NL,nrad)
+         real  tdqc3(NG,NL,nrad)
+         real  tdq(NG,NL,nrad,ntype-2+1)
+         real  tdqcn(NG,NL,nrad,ntype-2+1)
+*
+         real  gaz1(NG,NL)
+         real  gaz2(NG,NL)
+         real  gaz3(NG,NL)
+         real  dgaz1(NG,NL)
+         real  dgaz2(NG,NL)
+         real  dgaz3(NG,NL)
+*
+         real  ppch4(NG,NL)
+         real  ppc2h6(NG,NL)
+         real  ppn2(NG,NL)
+*
+         real  pmixch4(NL)
+         real  pmixc2h6(NL)
+         real  pmixn2(NL)
+c   composition initiale estimée (interne)
+         real  xprime1(NG,NL)
+         real  xprime2(NG,NL)
+         real  xprime3(NG,NL)
+c   composition calculée (output)
+         real  x1(NL)
+         real  x2(NL)
+         real  x3(NL)
+c   moyenne "glissante" pondéréee (output + mémoire)
+         real  x1o(NL)
+         real  x2o(NL)
+         real  x3o(NL)
+         real  icefrac(NL)
+         real  dmn2(NL+1)
+
+         real  ppch4t,ppc2h6t,ppn2t
+         real  psatch4,psatc2h6,psatn2
+         real  xprime(3),x(3),frac
+         real  melange
+         real  sum,sum0
+
+*                    RAPPEL: NG=1
+
+         real ddt
+         real masspaer
+
+         common/mixing/x1,x2,x3,icefrac,
+     &         pmixch4,pmixc2h6,pmixn2,
+     &         x1o,x2o,x3o
+
+
+
+c  FORMAT MICRO DES NUAGES
+c------------------------*
+
+         real  especes(NG,NL,3*nrad+1)          
+         real  condens(NG,NL,nrad)          
+         real gg,xmair
+
+         integer jsup,jinf,h,i,j,k,ndim
+         integer ival1,ival2,ival3
+
+         integer iprem
+
+         save iprem,xprime
+         data iprem/0/
+
+         ndim=3*nrad+1
+
+         gg=g0
+
+*********************************************
+*********************************************
+*  Appel de la condensation du methane
+*********************************************
+*********************************************
+
+
+
+*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
+*                   Bilan avant sur le methane                         *
+*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
+
+         do i=1,ng1  ! ng1=1 !!
+           do j=1,NL
+
+*  RAZ des delta d'especes communes.
+*----------------------------------
+             do k=1,nrad
+               tdqcn(i,j,k,1)= 0.
+               tdq( i,j,k,1) = 0.
+             enddo
+
+             gg=g0*rtit**2/(rtit+z(j))**2.
+             xmair=(pb(j+1)-pb(j))/gg/dzb(j)
+
+             do k=1,nrad
+               especes(i,j,k)=tq(i,j,k)         /xmair       ! aerosols, noyaux,
+               especes(i,j,k+nrad)=tqc1(i,j,k)  /xmair       ! methane condense,
+               condens(i,j,k)=(tqc2(i,j,k)+tqc3(i,j,k))/xmair! autre(s) condensat(s)
+               especes(i,j,k+2*nrad)=tqcn(i,j,k)/xmair       ! nombre/kg &  volume/kg
+             enddo
+             especes(i,j,3*nrad+1)=gaz1(i,j)*mch4/mair       ! methane gazeux kg/kg
+           enddo
+         enddo
+
+
+1001   format(7(1x,e12.6),' avN2CH4C2H6')
+1003   format(7(1x,e12.6),' miN2CH4C2H6')
+1002   format(7(1x,e12.6),' apN2CH4C2H6')
+*
+         call n_methane(ng1,ndim,nrad,ddt,
+     &                  p,t,r_e,especes,condens)
+
+
+*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
+*                   Bilan apres sur le methane                         *
+*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
+
+         do i=1,ng1
+           do j=1,NL
+
+             gg=g0*rtit**2/(rtit+z(j))**2.
+             xmair=(pb(j+1)-pb(j))/gg/dzb(j)
+
+*  ici ce sont les tendances a sortir de nuages.F pour le methane....
+*-------------------------------------------------------------------
+             sum=0.   
+             do k=1,nrad
+               tdqc1(i,j,k)=(especes(i,j,k+nrad)*xmair-tqc1(i,j,k) )
+               sum =sum+tdqc1(i,j,k)/xmair*rhoi_ch4
+               tqc1(i,j,k) = especes(i,j,k+nrad)*xmair
+             enddo
+
+             dgaz1(i,j)= especes(i,j,3*nrad+1)*mair/mch4-gaz1(i,j)
+             gaz1(i,j)= especes(i,j,3*nrad+1)*mair/mch4
+
+c         dgaz1(i,j)=-sum*xmuair/16.
+c          gaz1(i,j)=gaz1(i,j)+dgaz1(i,j) 
+
+*  Premiere tendance sur les variables communes (aerosols et noyaux)
+*------------------------------------------------------------------
+             do k=1,nrad
+               tdqcn(i,j,k,1)=(especes(i,j,k+2*nrad)*xmair-tqcn(i,j,k))
+               tdq( i,j,k,1) =(especes(i,j,k)*xmair       -tq(i,j,k))  
+             enddo
+           enddo
+         enddo
+
+
+
+*     attention, si il y a  de l'ethane sur les noyaux... il est impossible
+*     de les restituer - en revanche on peut en creer de nouveaux ! !!
+*     Le corrolaire de la condition ci dessus est que si il est impossible de 
+*     restituer des noyaux, le nombre d'aeorsols ne peux pas augmenter, il
+*     peut en revanche diminuer
+
+
+*********************************************
+*********************************************
+*  Appel de la condensation de l'ethane
+*********************************************
+*********************************************
+
+         do i=1,ng1
+           do j=1,NL
+             do k=1,nrad
+               tdqcn(i,j,k,2)= 0.
+               tdq( i,j,k,2) = 0.
+             enddo
+
+             gg=g0*rtit**2/(rtit+z(j))**2.
+             xmair=(pb(j+1)-pb(j))/gg/dzb(j)
+
+             do k=1,nrad
+               especes(i,j,k)=tq(i,j,k)/xmair
+               especes(i,j,k+nrad)=tqc2(i,j,k)/xmair           ! ethane condense
+               condens(i,j,k)=(tqc1(i,j,k)+tqc3(i,j,k))/xmair  ! autres condensats
+               especes(i,j,k+2*nrad)=tqcn(i,j,k)/xmair
+             enddo
+
+             especes(i,j,3*nrad+1)=gaz2(i,j)*mc2h6/mair       ! ethane gazeux
+
+           enddo
+         enddo
+
+
+
+         call n_ethane(ng1,ndim,nrad,ddt,
+     &                 p,t,r_e,especes,condens)
+
+         do i=1,ng1
+           do j=1,NL
+             gg=g0*rtit**2/(rtit+z(j))**2.
+             xmair=(pb(j+1)-pb(j))/gg/dzb(j)
+
+*  ici ce sont les tendances a sortir de nuages.F pour l'ethane....
+*-----------------------------------------------------------------
+
+             sum=0.
+             do k=1,nrad
+               tdqc2(i,j,k)=(especes(i,j,k+nrad)*xmair-tqc2(i,j,k) )
+               sum =sum+tdqc2(i,j,k)/xmair*rhoi_c2h6
+               tqc2(i,j,k) = especes(i,j,k+nrad)*xmair
+             enddo
+
+             dgaz2(i,j)=especes(i,j,3*nrad+1)*mair/mc2h6 - gaz2(i,j)
+             gaz2(i,j)=especes(i,j,3*nrad+1)*mair/mc2h6 
+
+c         dgaz2(i,j)=-sum*xmuair/30.
+c          gaz2(i,j)=gaz2(i,j)+dgaz2(i,j) 
+
+
+*  Deuxieme tendance sur les variables communes (aerosols et noyaux)
+*------------------------------------------------------------------
+   
+             do k=1,nrad
+               tdqcn(i,j,k,2)=(especes(i,j,k+2*nrad)*xmair-tqcn(i,j,k))
+               tdq(i,j,k,2)  =(especes(i,j,k)*xmair       -tq(i,j,k))
+             enddo
+
+           enddo
+         enddo
+
+
+*********************************************
+*********************************************
+*  Appel de la condensation de l'acethylene
+*********************************************
+*********************************************
+
+         do i=1,ng1
+           do j=1,NL
+             do k=1,nrad
+               tdqcn(i,j,k,3)= 0.
+               tdq( i,j,k,3) = 0.
+             enddo
+             gg=g0*rtit**2/(rtit+z(j))**2.
+             xmair=(pb(j+1)-pb(j))/gg/dzb(j)
+
+             do k=1,nrad
+               especes(i,j,k)=tq(i,j,k)/xmair
+               especes(i,j,k+nrad)=tqc3(i,j,k)/xmair           ! acethylene condense
+               condens(i,j,k)=(tqc1(i,j,k)+tqc2(i,j,k))/xmair  ! autres condensats
+               especes(i,j,k+2*nrad)=tqcn(i,j,k)/xmair
+             enddo
+
+             especes(i,j,3*nrad+1)=gaz3(i,j)*mc2h2/mair      ! acethylene gazeux
+
+           enddo
+         enddo
+
+         call n_acethylene(ng1,ndim,nrad,ddt,
+     &                     p,t,r_e,especes,condens)
+
+
+         do i=1,ng1
+           do j=1,NL
+
+             gg=g0*rtit**2/(rtit+z(j))**2.
+             xmair=(pb(j+1)-pb(j))/gg/dzb(j)
+
+*  ici ce sont les tendances a sortir de nuages.F pour l'ethane....
+*-----------------------------------------------------------------
+
+             sum=0.
+             do k=1,nrad
+               tdqc3(i,j,k)=(especes(i,j,k+nrad)*xmair-tqc3(i,j,k) )
+               sum =sum+tdqc3(i,j,k)/xmair*rhoi_c2h2
+               tqc3(i,j,k) = especes(i,j,k+nrad)*xmair
+             enddo
+
+             dgaz3(i,j)=especes(i,j,3*nrad+1)*mair/mc2h2 - gaz3(i,j)
+             gaz3(i,j)=especes(i,j,3*nrad+1)*mair/mc2h2 
+
+c         dgaz3(i,j)=-sum*xmuair/26.
+c         gaz3(i,j)=gaz3(i,j)+dgaz3(i,j) 
+
+*  Troisieme tendance sur les variables communes (aerosols et noyaux)
+*------------------------------------------------------------------
+
+
+             do k=1,nrad
+               tdqcn(i,j,k,3)=(especes(i,j,k+2*nrad)*xmair-tqcn(i,j,k))
+               tdq(i,j,k,3)  =(especes(i,j,k)*xmair       -tq(i,j,k))
+             enddo
+
+           enddo
+         enddo
+
+
+*  FIN DES APPELS DE NUAGES ET BILAN DES TENDANCES...
+*------------------------------------------------------------------
+
+
+         do i=1,ng1
+           do j=1,NL
+             do k=1,nrad
+
+*          Ici on test l'activité nuageuse : si on a l'association
+*          tdqcX(i,j,k) = 0 et tqcX(i,j,k) = 0 alors ivalX reste à 0 (pas d'ativité)
+*                                              sinon ivalX passe à 1 (activité)
+*------------------------------------------------------------------------------------
+
+               ival1=0
+               ival2=0
+               ival3=0
+
+               if(tdqc1(i,j,k).ne.0. .or. tqc1(i,j,k).gt.0.)  ival1=1
+               if(tdqc2(i,j,k).ne.0. .or. tqc2(i,j,k).gt.0.)  ival2=1
+               if(tdqc3(i,j,k).ne.0. .or. tqc3(i,j,k).gt.0.)  ival3=1
+
+*          Ici on definit la tendances des noyaux en faisant deux choses: 
+*          -1 On ecarte les cas  tdqcn(i,j,k,X)=0 si ils sont associés à une 
+*          absence d'activité nuageuse de l'espèce (tdqcX(i,j,k)=0.)
+*          -2 Sélectionne la tendance la plus élevée. Si aucune activité nuageuse
+*           n'exits dans cette case (ivalX=0 pour les 3 especes), alors on
+*           retrouve la valeur -1.e40 que l'on mets alors à 0. 
+*----------------------------------------------------------------------
+c23456789012345678901234567890123456789012345678901234567890123456789012
+
+               tdqcn(i,j,k,ntype-1)=-1.e40                      ! plus petite valeur possible 
+
+               if(ival1.eq.1.and.
+     &         tdqcn(i,j,k,1).ge.tdqcn(i,j,k,ntype-1)) ! Si activité de l'espece 1
+     &         tdqcn(i,j,k,ntype-1)=tdqcn(i,j,k,1)
+               if(ival2.eq.1.and.
+     &         tdqcn(i,j,k,2).ge.tdqcn(i,j,k,ntype-1)) ! Si activité de l'espece 2
+     &         tdqcn(i,j,k,ntype-1)=tdqcn(i,j,k,2)
+               if(ival3.eq.1.and.
+     &         tdqcn(i,j,k,3).ge.tdqcn(i,j,k,ntype-1)) ! Si activité de l'espece 3
+     &         tdqcn(i,j,k,ntype-1)=tdqcn(i,j,k,3)
+
+               if(tdqcn(i,j,k,ntype-1).le.-0.99e39) 
+     &         tdqcn(i,j,k,ntype-1)=0.
+
+               tdq(i,j,k,ntype-1)=1.e40                    ! plus grande valeur possible 
+
+               if(ival1.eq.1 .and. tdq(i,j,k,1).le.tdq(i,j,k,ntype-1)) ! Si activité de l'espece 1
+     &           tdq(i,j,k,ntype-1)=tdq(i,j,k,1)
+               if(ival2.eq.1 .and. tdq(i,j,k,2).le.tdq(i,j,k,ntype-1)) ! Si activité de l'espece 2
+     &           tdq(i,j,k,ntype-1)=tdq(i,j,k,2)
+               if(ival3.eq.1 .and. tdq(i,j,k,3).le.tdq(i,j,k,ntype-1)) ! Si activité de l'espece 3
+     &           tdq(i,j,k,ntype-1)=tdq(i,j,k,3)
+
+               if(tdq(i,j,k,ntype-1).ge.0.99e39) tdq(i,j,k,ntype-1)=0.
+
+                tqcn(i,j,k)=tqcn(i,j,k)+tdqcn(i,j,k,ntype-1)           ! Alors on ajoute les tendances (positive pour qcn ?)
+                tq(i,j,k)  =tq(i,j,k)  +tdq(i,j,k,ntype-1)             !
+
+                if(tqcn(i,j,k).le.0.) tqcn(i,j,k)=0.                   ! et on régularise les tableaux noyaux et aerosols.
+                if(tq(i,j,k)  .le.0.) tq(i,j,k)=0.                     !
+
+             enddo
+           enddo
+         enddo
+
+        continue
+
+1202    format(i2,1x,i2,6(1x,e12.4) )
+       return 
+       end
Index: trunk/LMDZ.TITAN/libf/phytitan/conf_phys.F90
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/conf_phys.F90	(revision 174)
+++ trunk/LMDZ.TITAN/libf/phytitan/conf_phys.F90	(revision 175)
@@ -367,4 +367,12 @@
 
 !
+!Config Key  = p_prodaer
+!Config Desc = pressure level for aerosol production (in Pa)
+!Config Def  = 1.
+!Config Help =
+!
+  p_prodaer = 1.
+  call getin('p_prodaer',p_prodaer)
+!
 !Config Key  = cutoff
 !Config Desc =
@@ -375,4 +383,25 @@
   call getin('cutoff',cutoff)
 
+!
+!Config Key  = clouds
+!Config Desc = activation des nuages
+!Config Def  = 1
+!Config Help =
+!
+  clouds = 1
+  call getin('clouds',clouds)
+  if (microfi.ne.1) clouds = 0      ! On  ne fait pas de nuages sans microphysique !
+
+!
+!Config Key  = xnuf
+!Config Desc = fraction nuageuse
+!Config Def  = 0.5
+!Config Help =
+!
+  xnuf = 0.5
+  call getin('xnuf',xnuf)
+  xnuf = amax1(xnuf,0.1)          ! On garde au minimum 10% de nuages.
+  if (clouds.eq.0) xnuf = 0.      ! Si il n'y pas de nuages, on ne met pas de fraction
+                                  ! nuageuse -> permet de retomber sur le TR habituel.
 !
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -448,5 +477,8 @@
   write(numout,*)' tx = ', tx
   write(numout,*)' tcorrect = ', tcorrect
+  write(numout,*)' p_prodaer = ', p_prodaer
   write(numout,*)' cutoff = ', cutoff
+  write(numout,*)' clouds = ', clouds
+  write(numout,*)' xnuf = ', xnuf
   write(numout,*)' lev_histmth = ',lev_histmth
   write(numout,*)' lev_histday = ',lev_histday 
Index: trunk/LMDZ.TITAN/libf/phytitan/cooling.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/cooling.F	(revision 174)
+++ trunk/LMDZ.TITAN/libf/phytitan/cooling.F	(revision 175)
@@ -1,3 +1,3 @@
-      SUBROUTINE COOLING(NL,PRESS,TEMP,Z,Q0,lwnet,pfluxi)
+      SUBROUTINE COOLING(NG,NL,PRESS,TEMP,Z,Q0,lwnet,pfluxi,icld)
 
 c=======================================================================
@@ -66,9 +66,9 @@
 c   ----------
 
-      INTEGER NL
-      REAL PRESS(ngrid,nl),TEMP(ngrid,nl)
-      REAL Z(ngrid,nl),Q0(ngrid,nl-1)
-      REAL lwnet(ngrid,nl),UBARI2
-      real pfluxi(ngrid)
+      INTEGER NG,NL,icld
+      REAL PRESS(NG,NL),TEMP(NG,NL)
+      REAL Z(NG,NL),Q0(NG,NL-1)
+      REAL lwnet(NG,NL),UBARI2
+      real pfluxi(NG)
 
 
@@ -77,6 +77,7 @@
 
 C DTAU IS PASSED EN-MASS, SO ITS DEMENSIONS ARE CRITICAL
-      COMMON /IRTAUS/ DTAUI(ngrid,NLAYER,NSPECI)
-      REAL dtaui
+      REAL dtaui(ngrid,NLAYER,NSPECI)
+      REAL dtauip(ngrid,NLAYER,NSPECI)
+      COMMON /IRTAUS/ dtaui,dtauip
 
 c   Local:
@@ -88,5 +89,5 @@
       REAL DW,WAVEN,TJ,BSURF,QOUT,QIN,eff_g,COLDEN
 
-      INTEGER ig,K,J,NLEVEL,I,L
+      INTEGER ig,K,J,I,L
 
 c     EXTERNAL PLNCK
@@ -139,5 +140,4 @@
       UBARI2=1./1.66
       UBARI2=UBARI
-      NLEVEL=NL
 
 C ZERO THE NET FLUXES
@@ -161,6 +161,6 @@
           B0 = 0.
 
-          DO J=1,NLEVEL-1
-             DO ig=1,ngrid
+          DO J=1,NL-1
+             DO ig=1,NG
                 TJ=TEMP(ig,J)
 
@@ -182,8 +182,15 @@
              ENDDO
 
-             DO ig=1,ngrid
-             zz4=EXP(-DTAUI(ig,J,K)/UBARI2)
-                EM(ig,J)=zz4
-            ENDDO
+             IF (ICLD.EQ.1) THEN
+               DO ig=1,NG
+                 zz4=EXP(-DTAUI(ig,J,K)/UBARI2)
+                 EM(ig,J)=zz4
+               ENDDO
+             ELSE
+               DO ig=1,NG
+                 zz4=EXP(-DTAUIP(ig,J,K)/UBARI2)
+                 EM(ig,J)=zz4
+               ENDDO
+             ENDIF
           ENDDO
 
@@ -197,6 +204,6 @@
            FUPIS=0.
 
-        DO 2220 J=1,NLEVEL-1
-           DO 2230 ig=1,ngrid
+        DO 2220 J=1,NL-1
+           DO 2230 ig=1,NG
               FDI(ig,J+1) = FDI(ig,J)*EM(ig,J) + 2.*RPI*UBARI*
      &        B0(ig,J)*(1.-EM(ig,J))
@@ -218,26 +225,26 @@
 C UPWARD FLUXES: SURFACE EMISSIONS
 
-        DO 2310 ig=1,ngrid
+        DO 2310 ig=1,NG
           PLNCK=0.
           DO I=-2,2,1
              WAVNUM=WAVEN + I*zz1
-             zz2=EXP(-1.4388 * WAVNUM/TEMP(ig,NLEVEL))
+             zz2=EXP(-1.4388 * WAVNUM/TEMP(ig,NL))
              zz3=WAVNUM*WAVNUM*WAVNUM
              PLNCK=PLNCK+1.191E-5* zz3*zz2/(1.-zz2)
           ENDDO
-c          BSURF=PLNCK( WAVEN, TEMP(ig,NLEVEL), DW)
+c          BSURF=PLNCK( WAVEN, TEMP(ig,NL), DW)
            BSURF=.2*PLNCK
-        FUPI(ig,NLEVEL)=BSURF * 2.*RPI*UBARI + RSFI*FDI(ig,NLEVEL)
-        FUPIS(ig,NLEVEL,K)=BSURF*2.*RPI*UBARI+RSFI*FDIS(ig,NLEVEL,K)
+        FUPI(ig,NL)=BSURF * 2.*RPI*UBARI + RSFI*FDI(ig,NL)
+        FUPIS(ig,NL,K)=BSURF*2.*RPI*UBARI+RSFI*FDIS(ig,NL,K)
 2310    CONTINUE
 c     write(*,*)
-c     write(*,*) 'cooling : FUPI/NLEVEL =' ,
-c    & ((FUPI(i,l),l=nl,nl),i=1,ngrid)
-c     write(*,*)
-c     write(*,*) 'cooling : FDI/NLEVEL =' ,
-c    & ((FDI(i,l),l=nl,nl),i=1,ngrid)
-
-        DO 2320 J=NLEVEL-1,1,-1
-           DO 2330 ig=1,ngrid
+c     write(*,*) 'cooling : FUPI/NL =' ,
+c    & ((FUPI(i,l),l=nl,nl),i=1,NG)
+c     write(*,*)
+c     write(*,*) 'cooling : FDI/NL =' ,
+c    & ((FDI(i,l),l=nl,nl),i=1,NG)
+
+        DO 2320 J=NL-1,1,-1
+           DO 2330 ig=1,NG
               FUPI(ig,J) = FUPI(ig,J+1)*EM(ig,J) + 2.*RPI*UBARI*
      &        B0(ig,J)*(1.-EM(ig,J))
@@ -258,18 +265,18 @@
 c compute the downward IR flux at the surface:
 c 
-          DO 3520 ig=1,ngrid
-             pfluxi(ig)=pfluxi(ig)+ DWNI(K)*FDI(ig,NLEVEL)
+          DO 3520 ig=1,NG
+             pfluxi(ig)=pfluxi(ig)+ DWNI(K)*FDI(ig,NL)
 3520      CONTINUE
 
 c compute the net IR flux, (+) upward:
 c 
-          DO J=1,NLEVEL
-          DO ig=1,ngrid
+          DO J=1,NL
+          DO ig=1,NG
              lwnet(ig,J)= lwnet(ig,J)+ DWNI(K)*(FUPI(ig,J)-FDI(ig,J))
           ENDDO
           ENDDO
 	  
-          DO 3210 J=1,NLEVEL-1
-             DO 3220 ig=1,ngrid
+          DO 3210 J=1,NL-1
+             DO 3220 ig=1,NG
                 QOUT=FUPI(ig,J) + FDI(ig,J+1)   ! OUT OF LAYER
                 QIN =FDI(ig,J)  + FUPI(ig,J+1)  ! INTO LAYER
@@ -297,5 +304,5 @@
 
 c   convertion erg/cm2 -> J/m2
-      DO 3550 ig=1,ngrid
+      DO 3550 ig=1,NG
          pfluxi(ig)  = 1.e-3*pfluxi(ig)
 	 lwnet(ig,:) = 1.e-3*lwnet(ig,:)
@@ -307,7 +314,7 @@
 C COMPUTE THE BASELINE COOLING RATE
 
-       DO 3000 J=1,NLEVEL-1
+       DO 3000 J=1,NL-1
 C TURN THE Q'S INTO TIMESCALES.....
-          DO 3300 ig=1,ngrid
+          DO 3300 ig=1,NG
              eff_g = RG*(RA/(RA+Z(ig,J)))**2 ! 10% DIFF AT 1 MBAR
              COLDEN = RHOP*(PRESS(ig,J+1)-PRESS(ig,J))/eff_g
Index: trunk/LMDZ.TITAN/libf/phytitan/diagmuphy.h
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/diagmuphy.h	(revision 175)
+++ trunk/LMDZ.TITAN/libf/phytitan/diagmuphy.h	(revision 175)
@@ -0,0 +1,35 @@
+!     Ce header contient toutes les variables
+!     diagnostiques sorties de la microphysique.
+!
+!  ASTUCE POUR EVITER klon... EN ATTENDANT MIEUX
+      INTEGER   ngd
+      PARAMETER (ngd=(jjm-1)*iim+2)  ! = klon
+!
+! ---- flux de glace (1:CH4 / 2:C2H6 / 3:C2H2)
+       REAL flxesp_i(ngd,llm,3)
+! ---- taux sedimentation gouttes
+       REAL tau_drop(ngd,llm)
+! ---- taux sedimentation aerosols sec
+       REAL tau_aer(ngd,llm,nrad)
+! ---- Production de glace (negatif si disparition)
+       REAL solesp(ngd,llm+1,3)
+! ---- occurences des nuages
+       REAL occcld_m(ngd,llm,12) 
+! ---- occcld sert a obtenir les opacités/extinction des nuages (proxy)
+       REAL occcld(ngd,llm)
+! ---- saturation CH4 
+       REAL satch4(ngd,llm)
+! ---- saturation C2H6
+       REAL satc2h6(ngd,llm)
+! ---- saturation C2H2 
+       REAL satc2h2(ngd,llm)
+! ---- precipitations (CH4, C2H6, C2H2, noyaux, aerosols)
+       REAL prec(ngd,5)
+! ---- rayon moyen des gouttes
+       REAL rmcloud(ngd,llm)
+    
+       common/diagmuphy/flxesp_i,tau_drop,tau_aer,                      &
+     &                  solesp,occcld_m,occcld,                         &
+     &                  satch4,satc2h6,satc2h2,                         &
+     &                  prec,rmcloud
+
Index: trunk/LMDZ.TITAN/libf/phytitan/effg.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/effg.F	(revision 174)
+++ trunk/LMDZ.TITAN/libf/phytitan/effg.F	(revision 175)
@@ -1,6 +1,5 @@
       FUNCTION EFFG(Z)
-      DATA G/1.35/
-      DATA RPLANT/2575./
-      EFFG = G * (RPLANT/(RPLANT + Z ) )**2
+#include "YOMCST.h"
+      EFFG = RG * (RA/(RA + Z ) )**2
       RETURN
       END
Index: trunk/LMDZ.TITAN/libf/phytitan/getimes.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/getimes.F	(revision 175)
+++ trunk/LMDZ.TITAN/libf/phytitan/getimes.F	(revision 175)
@@ -0,0 +1,128 @@
+c==========================================================
+c                       getimes.F
+c==========================================================
+c    Pack de routines pour calculer des temps d'execution.
+c
+c    UTILISATION :
+c    L'appel a la routine initimes() doit se faire en 
+c    début de programme.
+c    Pour calculer le temps d'execution d'une portion de
+c    code il suffit de placer la routine begintime devant
+c    la portion et la routine endtime après la portion.
+c
+c    L'argument tps de la routine endtime retourne le 
+c    temps d'execution en seconde de la portion de code.
+c==========================================================
+
+**************************************************
+*  routine begintime                             *
+*  Retourne dans la variable nb_ini, le nombre de*
+*  cycle au moment de l'appel a begintime.       *
+*                                                *
+*  ARGUMENTS :                                   *
+*  nb_ini (output) : nombre de cycle au lancement*
+*                    de la routine.              *
+**************************************************
+      subroutine begintime(nb_ini)
+        integer nb_ini
+        CALL SYSTEM_CLOCK(COUNT=nb_ini)
+        return
+      end
+
+
+**************************************************
+*  routine endtime                               *
+*  Retourne dans la variable tps, le temps entre *
+*  l'appel a begintime et endtime.               *
+*                                                *
+*  ARGUMENTS :                                   *
+*  nb_ini (input) : nombre de cycle au lancement *
+*                   de la routine begintime      *
+*  tps (output)   : temps en secondes ecoules    *
+*                   entre begintime et endtime   *
+**************************************************
+       subroutine endtime(nb_ini,tps)
+       implicit none
+         integer nb_max,nb_sec
+         common/horloge/nb_max,nb_sec
+         integer nb_ini
+         integer nb_fin,tmp
+         real tps
+         CALL SYSTEM_CLOCK(COUNT=nb_fin)
+         tmp =nb_fin-nb_ini
+         if (nb_fin.lt.nb_ini) tmp=tmp+nb_max
+         tps = FLOAT(tmp)/ nb_sec
+         return
+       end
+
+**************************************************
+*  routine initimes                              *
+*  Initialise le compteur                        *
+*  Cette routine doit se positionnee en debut de *
+*  programme                                     *
+**************************************************
+       subroutine initimes()
+#include "itemps.h"
+         integer nb_max,nb_sec
+         common/horloge/nb_max,nb_sec
+         CALL SYSTEM_CLOCK(COUNT_RATE=nb_sec,
+     &                      COUNT_MAX=nb_max)
+*        initialisation variables de stockage
+         ttdynt   = 0.
+         ttadvtr  = 0.
+         ttphys   = 0.
+         ttmuphys = 0.
+         tthaze   = 0.         
+         ttcclds  = 0.
+         ttsclds  = 0.
+         ttrad    = 0.
+         ttphytra = 0.
+         
+         return
+       end
+
+
+**************************************************
+*  routine printimes                             *
+*  affiche des temps d'execution.                *
+*  iout : sortie dans un fichier.                *
+*   iout = 0 ---> sortie ecran                   *
+*   iout = 1 ---> sortie dans temps.out          *
+**************************************************
+       subroutine printimes(iout)
+#include "itemps.h"
+         integer iunit
+         logical ok
+         ok = .true.
+         iunit = 9
+         if (iout.eq.0) then
+           iunit = 6
+         else
+           do while (ok)
+             iunit = iunit+1
+             inquire(unit=iunit,OPENED=ok)
+             if (iunit.eq.100) exit
+           enddo
+             if (iunit.eq.100) then
+               print*,"Je n'ai pas trouve d'unite logique libre."
+               print*,"J'affiche les temps a l'ecran."
+               iunit = 6
+             endif
+         endif 
+         if (iunit.ne.6) open(iunit,file="tpsprog")
+         write(iunit,*) "#############################################"
+         write(iunit,*) "ttdynt        :",ttdynt
+         write(iunit,*) "  ttdyn       :",ttdynt-ttphys
+         write(iunit,*) "  ttadvtr     :",ttdyntr
+         write(iunit,*) "  ttphys      :",ttphys
+         write(iunit,*) "    ttrad     :",tthaze
+         write(iunit,*) "    ttphytra  :",ttphytra
+         write(iunit,*) "    ttmuphys  :",ttmuphys
+         write(iunit,*) "      tthaze  :",tthaze
+         write(iunit,*) "      ttcclds :",ttcclds
+         write(iunit,*) "      ttsclds :",ttsclds
+         write(iunit,*) "#############################################"
+         if (iunit.ne.6) close(iunit)
+         return
+       end
+
Index: trunk/LMDZ.TITAN/libf/phytitan/heating.F
===================================================================
--- trunk/LMDZ.TITAN/libf/phytitan/heating.F	(revision 174)
+++ trunk/LMDZ.TITAN/libf/phytitan/heating.F	(revision 175)
@@ -1,3 +1,3 @@
-       SUBROUTINE heating(dist,rmu0,fract,sol_htg,swnet)
+       SUBROUTINE heating(dist,rmu0,fract,sol_htg,swnet,icld)
 
 
@@ -16,4 +16,5 @@
 c rmu0-----input-R- cosinus de l'angle zenithal
 c fract----input-R- duree d'ensoleillement normalisee
+c icld-----input-I- calcul avec nuages.
 c        p(klon,nl)    pressure (level)
 c
@@ -46,4 +47,5 @@
 
       real dist, rmu0(klon), fract(klon)
+      integer icld
 
       real sol_htg(klon,klev)
@@ -96,5 +98,5 @@
                ubar0=rmu0(ig)
 
-               CALL sfluxv(iprint,ig,dist)           ! #3
+               CALL sfluxv(iprint,ig,dist,icld)           ! #3
 
                fnetv(ig,:) = fnetv(ig,:) *fract(ig)   ! >0 vers le haut
